/* (C) 2001-2002 Andrew J. Kroll */
/* see file README for license details */
/*

All together now! This connects TCP to IP, and connects SOCKETS to TCP.

*/

#include "config.h"
#include "tcpvars.h"
#include "slip.h"
#include "in.h"
#include "netinet.h"
#include <time.h>
#include "ip.h"
#include "socket.h"

#define TCPIPVERBOSE 0 
/* initialize tcpip and socket variables, bring up device */
void varinit(VOIDFIX)
{

	struct tm t;
	int i;

	printf("TCP/IP stack Copyright 2001-2002 Andrew J. Kroll, http://tcp.dr.ea.ms/\n");
	sockets = malloc(SOKDAT * SOKALLOW);

	memset(sockets, 0, (SOKDAT * SOKALLOW));

	for(i = 0; i < BUFFERS + 1; i++) {
		timertx[i] = 0x00;
		errortx[i] = 0x00;
		txrxflags[i] = 0x00;
#if HANDLEFRAGS
		fragtime[i] = 0;
#endif
		sockdlen[i] = 0;
		rbufcount[i] = 0;
		wbufcount[i] = 0;
		bufptrs[i] = NULL;
		rdatapointers[i] = NULL;
		wdatapointers[i] = NULL;
	}
	initializedev();
	tock=TIMETICK;
#if HAVE_RTC
	/* Linux, ELKS, DOS, OS/M, MP/M, Concurrent-CP/M and CP/M+ (CP/M 3.x) ISN init */
	isnclock=time((time_t *)&t);
	if(isnclock == 0) {
		isnclock=t.tm_sec + (t.tm_min * 60) + (t.tm_hour * 60) + (t.tm_yday * 3600);
	}
	if(isnclock == 0) {
		isnclock = rand();
#if TCPIPVERBOSE
		printf("\nNO RTC!!! ISN=%8.8lx\n", isnclock);
#endif
	}
#if TCPIPVERBOSE
	else {
		printf("\nTIME %s ISN=%8.8lx\n", ctime((time_t *)&t), isnclock);
	}
#endif
#else
	/* no RTC */
	isnclock = rand();
#if TCPIPVERBOSE
	printf("\nISN=%8.8lx\n", isnclock);
#endif
#endif
	portcounter=(isnclock & 0x0fff) + (isnclock & 0xf);
	while ((portcounter < 32768) || (portcounter > 65000)) portcounter=portcounter*2+12800;
}

/* tell link parser who we are and where we belong

0400 libznet.lib tcpip.obj xxLIBRARYxx

*/

